'use strict'
Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' })
const toSingleLine = require('./to-single-line.js')
const makeFixes = require('./make-fixes.js')
let reportErrors = ({
  firstUnorderedNodeDependentOnRight,
  ignoreFirstNodeHighestBlockComment,
  sortedNodes,
  messageIds,
  sourceCode,
  context,
  options,
  nodes,
  right,
  left,
}) => {
  for (let messageId of messageIds) {
    context.report({
      data: {
        nodeDependentOnRight:
          firstUnorderedNodeDependentOnRight == null
            ? void 0
            : firstUnorderedNodeDependentOnRight.name,
        right: toSingleLine.toSingleLine(right.name),
        left: toSingleLine.toSingleLine(left.name),
        rightGroup: right.group,
        leftGroup: left.group,
      },
      fix: fixer =>
        makeFixes.makeFixes({
          ignoreFirstNodeHighestBlockComment,
          sortedNodes,
          sourceCode,
          options,
          fixer,
          nodes,
        }),
      node: right.node,
      messageId,
    })
  }
}
exports.reportErrors = reportErrors
